
Imports System.Diagnostics

public Class Form1

    Inherits System.Windows.Forms.Form

    Dim Ciclo1 As Short ' cicli vari
    Dim Ciclo2 As Short ' cicli vari
    Dim Partenza As Date = DateTime.Now  ' data e ora di inizio gioco
    Dim ClicX As Short ' coordinata X della casella cliccata
    Dim ClicY As Short ' coordinata Y della casella cliccata
    Dim XvuotoDX As Boolean
    Dim XvuotoSX As Boolean
    Dim YvuotoSU As Boolean
    Dim YvuotoGIU As Boolean
    Dim DiffCaselleX As Short ' distanza orizzontale tra la casella vuota e la casella cliccata
    Dim DiffCaselleY As Short ' distanza verticale tra la casella vuota e la casella cliccata
    Dim Casella As Short ' indice della casella cliccata
    Dim VuotoX As Short ' coordinate cha avrebbe una casella vuota
    Dim VuotoY As Short ' coordinate cha avrebbe una casella vuota
    Dim PosVuoto As Short ' posizione del 16 in SequenzaGenerata
    Dim Tempo As Date ' data e ora letta ogni 100 millisecondi
    Dim SequenzaGenerata As String ' sequenza in formato "010203..." 16 = casella vuota,  il DNA del programma
    Dim Mosse As Integer = 0
    Dim pictTasto(14) As PictureBox ' le 15 caselle
    Dim DimTessera As Integer = 56
    Dim Rnd1 As New Random()
    Dim Velocita As Short = 8 ' velocit scorrimento
    Dim MescolaReale As Boolean ' cambia il comportamento di PictTasto_OnClick quando si mescola
    Dim SpostaMultiploX(4) As Short ' informazioni di spostamento documentate su PictTasto_OnClick
    Dim SpostaMultiploY(4) As Short ' informazioni di spostamento documentate su PictTasto_OnClick

    ' aggiungi le sequenze preferite con il loro nome, le sequenze aggiunte verranno automaticamente gestite
    ' attenzione alle doppie graffe {{.....}}

    Dim ArraySequenze(,) As String = {{"01020304050607080910111213141516", "Sequenza Classica"},
                                      {"16010203040506070809101112131415", "Sequenza Sam Loyd"},
                                      {"01050913020610140307111504081216", "Sequenza Verticale"},
                                      {"16040812010509130206101403071115", "Sequenza Verticale inversa"},
                                      {"01121110021316090314150804050607", "Sequenza Spirale"},
                                      {"16111009011215080213140703040506", "Sequenza Spirale inversa"},
                                      {"01080916020710150306111404051213", "Sequenza ZigZag Verticale"},
                                      {"16070815010609140205101303041112", "Sequenza ZigZag Verticale inversa"},
                                      {"01020304080706050910111216151413", "Sequenza ZigZag"},
                                      {"16010203070605040809101115141312", "Sequenza ZigZag inversa"}}


    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim Tessere As Integer
        Dim OffSetTop As Integer = 56
        Dim OffSetLeft As Integer = 36

        Me.SuspendLayout() ' evita la visibilt della preparazione del form

        RectangleShape1.Width = DimTessera * 4 + 7 ' piccoli aggiustamenti perch la RectangleShape1 la voglio pi grande di PictureBox1
        RectangleShape1.Height = DimTessera * 4 + 7
        RectangleShape1.Top = OffSetTop - 4
        RectangleShape1.Left = OffSetLeft - 4
        PictureBox1.Width = DimTessera * 4 ' PictureBox1 far da contenitore a picTasto()
        PictureBox1.Height = DimTessera * 4
        PictureBox1.Top = OffSetTop
        PictureBox1.Left = OffSetLeft

        For Tessere = 0 To 14
            pictTasto(Tessere) = New PictureBox ' creo le 15 PictureBox
            pictTasto(Tessere).Width = DimTessera
            pictTasto(Tessere).Height = DimTessera
            pictTasto(Tessere).Name = "Tes" & Tessere.ToString ' parametro inutilizzto
            pictTasto(Tessere).Image = ImageList1.Images.Item(Tessere) ' associazione indice, immagine
            pictTasto(Tessere).Left = DimTessera * (Tessere Mod 4) ' ccordinata X calcolata
            pictTasto(Tessere).Top = DimTessera * (Math.Ceiling(Tessere \ 4)) ' coordinata Y calcolata
            pictTasto(Tessere).Tag = Tessere + 1 ' corrispondenza immagine con numero rappresentato
            Me.PictureBox1.Controls.Add(pictTasto(Tessere)) ' aggiungo a PictureBox1 usato come contenitore per avere le coordinate invariate anche se si sposta il puzzle nel form
            AddHandler pictTasto(Tessere).Click, AddressOf PictTasto_OnClick ' permette di avere l'evento click
            SequenzaGenerata = SequenzaGenerata & (Tessere + 100 + 1).ToString.Substring(1, 2) 'sequenza delle 15 caselle
        Next Tessere

        SequenzaGenerata = SequenzaGenerata & "16"  ' aggiungo la casella vuota: 16 = casella vuota
        Debug.Print(SequenzaGenerata)

        Dim iCombo As Short
        For iCombo = 0 To ArraySequenze.GetUpperBound(0) ' popolo il combo con i nomi delle sequenze
            ComboBox1.Items.Add(ArraySequenze(iCombo, 1))
        Next iCombo

        Me.ResumeLayout() ' mostra il contenuto del form

    End Sub

    Private Sub cmdMescolaReale_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdMescolaReale.Click

        Dim ciclo As Short
        Dim Numero As Short

        lblinfo.Text = ""

        MescolaReale = True ' cambia il comportamento di PicTasto_OnClick
        For ciclo = 1 To 500 'mescolo la sequenza di partenza pistando tasti a caso
            Numero = Rnd1.Next(0, 15) ' una casella da 0 a 14
            Call PictTasto_OnClick(pictTasto(CShort(Numero)), New System.EventArgs()) ' chiamo la routine che verifica se le caselle si possono muovere
            lblinfo.Text = CStr(Mosse) ' visualizzo il numero delle mosse fatte
            lblinfo.Refresh() ' rendo visibile l'avanzamento delle mosse
            PictureBox1.Refresh() ' rendo visibile il movimento delle caselle
        Next ciclo
        MescolaReale = False

        Partenza = DateTime.Now 'memorizzo la data e l'ora di partenza, serve per calcolare il tempo trascorso
        'Tempo = DateTime.FromOADate(0) 'memorizzo l'ora di partenza
        Mosse = 0
        Label1.Text = "click su una casella numerata"

        Timer1.Enabled = True ' fa scorrere il tempo
        lblinfo.BackColor = Color.White
        shpMescolaReale.Visible = True

    End Sub

    Private Sub PictTasto_OnClick(ByVal sender As System.Object, ByVal e As System.EventArgs)

        'If Timer2.Enabled = True Then Exit Sub
        ClicX = sender.Left ' coordinata X della casella cliccata
        ClicY = sender.Top ' coordinata Y della casella cliccata
        Casella = sender.tag() - 1 ' indice della casella cliccata su variabile globale per uso in altre routine, tag base1, indice base0

        TrovaVuoto(SequenzaGenerata) ' mette in VuotoX e VuotoY le coordinate della casella vuota, e posizione in sequenzagenerata
        DiffCaselleX = 0
        DiffCaselleY = 0

        ' 4 sono le combinazioni gestite:
        ' 1) la casella pu scorrere a destra
        ' 2) la casella pu scorrere a sinstra
        ' 3) la casella pu scorrere in alto
        ' 4) la casella pu scorrere in basso

        If VuotoX = ClicX Then 'combinazione(3-4)
            DiffCaselleY = VuotoY - ClicY ' distanza vuoto, casella, negativa o positiva
            ' la casella pu scorrere in verticale 

            'SpostaMultiploY(0) e SpostaMultiploX(0) quante caselle dovr muovere in timer2 (1,3), zero = nessuna
            'SpostaMultiploY(1) e SpostaMultiploX(1) indice/valore della casella1
            'SpostaMultiploY(2) e SpostaMultiploX(2) indice/valore della casella2
            'SpostaMultiploY(3) e SpostaMultiploX(3) indice/valore della casella3
            'SpostaMultiploY(4) e SpostaMultiploX(4) -1 per decrementare le coordinate, +1 per incrementarle

            SpostaMultiploY(0) = Math.Abs(DiffCaselleY / DimTessera) 'quante caselle devo spostare
            SpostaMultiploX(0) = 0 'niente in orizzontale

            If DiffCaselleY > 0 Then 'combinazione(4)
                SpostaMultiploY(4) = 1 ' spostameto positivo
                Select Case SpostaMultiploY(0) ' quante caselle devo spostare

                    Case Is = 1
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = -1
                        SpostaMultiploY(3) = -1

                    Case Is = 2
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = -1

                    Case Is = 3
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 4 * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 8 * 2 - 2, 2)) - 1

                End Select
            Else 'combinazione(3)
                SpostaMultiploY(4) = -1 ' spostameto negativo
                Select Case SpostaMultiploY(0) ' quante caselle devo spostare

                    Case Is = 1 'casella singola
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = -1
                        SpostaMultiploY(3) = -1

                    Case Is = 2 ' coppia di caselle
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = -1

                    Case Is = 3 ' tre caselle
                        SpostaMultiploY(1) = Casella
                        SpostaMultiploY(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 4 * 2 - 2, 2)) - 1
                        SpostaMultiploY(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 8 * 2 - 2, 2)) - 1

                End Select
            End If
            Mosse += 1
            If MescolaReale Then EsegueSpostamento() Else Timer2.Enabled = True ' in fase di mescolamento non si esegue la routine con lo scorrimento
        End If

        If VuotoY = ClicY Then 'combinazione(1-2)
            DiffCaselleX = VuotoX - ClicX ' di quanto pu scorrere negativo positivo
            ' la casella pu scorrere in orizzontale

            SpostaMultiploX(0) = Math.Abs(DiffCaselleX / DimTessera)
            SpostaMultiploY(0) = 0 'niente in verticale
            If DiffCaselleX > 0 Then 'combinazione(1)
                SpostaMultiploX(4) = 1 ' spostameto positivo
                Select Case SpostaMultiploX(0) ' quante caselle devo spostare

                    Case Is = 1
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = -1
                        SpostaMultiploX(3) = -1

                    Case Is = 2
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = -1

                    Case Is = 3
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto - 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto - 2 * 2 - 2, 2)) - 1

                End Select
            Else 'combinazione(2)
                SpostaMultiploX(4) = -1 ' spostameto negativo
                Select Case SpostaMultiploX(0) ' quante caselle devo spostare e quali

                    Case Is = 1
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = -1
                        SpostaMultiploX(3) = -1

                    Case Is = 2
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = -1

                    Case Is = 3
                        SpostaMultiploX(1) = Casella
                        SpostaMultiploX(2) = CShort(SequenzaGenerata.Substring(PosVuoto + 1 * 2 - 2, 2)) - 1
                        SpostaMultiploX(3) = CShort(SequenzaGenerata.Substring(PosVuoto + 2 * 2 - 2, 2)) - 1

                End Select
            End If
            Mosse += 1
            If MescolaReale Then EsegueSpostamento() Else Timer2.Enabled = True ' in fase di mescolamento non si esegue la routine con lo scorrimento
        End If

    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick

        Tempo = DateTime.FromOADate(DateTime.Now.ToOADate - Partenza.ToOADate) ' calcolo del tempo trascorso (con Now il tempo viene correttamente calcolato anche a cavallo della mezzanotte e si pu anche includere il numero dei giorni trascorsi, poich Now restituisce la data e l'ora)
        lblinfo.Text = "Tempo " & Tempo & " e " & Mosse & " mosse"

    End Sub

    Private Sub Timer2_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer2.Tick

        Dim Col As Short
        Dim Rig As Short
        Dim Trovato As Boolean = False
        Static a As Short
        Dim nCaselle As Short

        a = a + Velocita 'controllo avanzamento
        If a > DimTessera Then a = DimTessera ' i controlli vengono fatti usando le coordinate delle picture,  indispensabile che siano multipli di DimTessera

        For nCaselle = 1 To SpostaMultiploY(0) ' quante caselle devo spostare (0,3)
            pictTasto(SpostaMultiploY(nCaselle)).Top = pictTasto(SpostaMultiploY(nCaselle)).Top + Velocita * SpostaMultiploY(4) ' cambia la coordinata Y della casella 
        Next nCaselle

        For nCaselle = 1 To SpostaMultiploX(0) ' quante caselle devo spostare
            pictTasto(SpostaMultiploX(nCaselle)).Left = pictTasto(SpostaMultiploX(nCaselle)).Left + Velocita * SpostaMultiploX(4) ' cambia la coordinata X della casella 
        Next nCaselle

        If a = DimTessera Then ' se la casella cliccata  arrivata in posizione
            a = 0 ' azzero per il prossimo scorrimento
            Timer2.Enabled = False ' finiti i controlli non si dovr rientrare in timer2
            ' Console.Beep(200, 1) ' rumore della casella che sbatte
        Else ' altrimenti la casella cliccata sta scorrendo
            Exit Sub ' si esce e timer2 ancora attivo, rientrer aspettando in base al valore di interval, per proseguire lo scorrimento
        End If

        '---------------- Alla fine dello scorrimento ricreo la sequenza -------------

        SequenzaGenerata = ""

        'Non conosco la nuova disposizione, la ricavo interrogando tutte le posizioni possibili 
        For Rig = 0 To DimTessera * 3 Step DimTessera
            For Col = 0 To DimTessera * 3 Step DimTessera
                For Ciclo1 = 0 To 14 'trovo l'indice della casella nelle coordinate in esame
                    If pictTasto(Ciclo1).Left = Col And pictTasto(Ciclo1).Top = Rig Then
                        Trovato = True ' se troveto resta a false significa che nelle coordinate in esame non c' una casella
                        Exit For ' inutile proseguire
                    End If
                Next Ciclo1
                If Trovato = False Then ' non c'era una casella
                    SequenzaGenerata = SequenzaGenerata & "16" ' 16  la casella vuota
                Else
                    SequenzaGenerata = SequenzaGenerata & (Ciclo1 + 100 + 1).ToString.Substring(1, 2) ' converto l'indice in stringa da 2 caratteri con zero avanti se serve
                    Trovato = False
                End If
            Next Col
        Next Rig

        Debug.Print(SequenzaGenerata)

        '--------------- Controllo la soluzione --------------------

        Dim iCombo As Short
        For iCombo = 0 To ArraySequenze.GetUpperBound(0)
            If ArraySequenze(iCombo, 0) = SequenzaGenerata Then
                Timer1.Enabled = False
                lblinfo.Text = Mosse & " mosse in: " & Tempo
                lblinfo.BackColor = Color.Yellow
                Label1.Text = "HAI RISOLTO LA " & ArraySequenze(iCombo, 1)
                Do
                    Windows.Forms.Application.DoEvents() ' permette a timer2 di continuare a spostare la casella mentre suona
                Loop While a = DimTessera ' aspetta che la casella sia arrivata in posizione
                Console.Beep(1000, 50)
                Console.Beep(3000, 50)
                Console.Beep(1000, 50)
                Console.Beep(3000, 100)
                Console.Beep(2000, 500)
                Exit Sub
            Else
                Timer1.Enabled = True
                Label1.Text = "click su una casella numerata"
                lblinfo.BackColor = Color.White
            End If
        Next iCombo
 
    End Sub

    Private Sub TrovaVuoto(ByVal SequenzaAttuale As String)

        'SequenzaAttuale = "00000000000000000000000000000016" ' per test calcoli
        PosVuoto = SequenzaAttuale.IndexOf("16") + 2 ' controllo dove  il 16, aggiungo 2 per lavorare con la seconda posizione, posVuoto  usato anche da PictTasto_OnClick
        VuotoX = ((PosVuoto - 2) / 2 Mod 4) * DimTessera ' calcolo le coordinate X che avrebbe una tessera nella posizione vuota, VuotoX  usato da PictTasto_OnClick
        VuotoY = Math.Ceiling((PosVuoto - 2) / 2 \ 4) * DimTessera ' calcolo le coordinate Y che avrebbe una tessera nella posizione vuota,, VuotoY  usato da PictTasto_OnClick

    End Sub

    Private Sub EsegueSpostamento()

        ' codice simile a quello di timer2, senza scorrimento e controllo soluzione
        ' viene eseguito quando si clicca il tasto mescola

        Dim Posizione(15) As Short
        Dim Col As Short
        Dim Rig As Short
        Dim Trovato As Boolean = False
        Dim nCaselle As Short

        For nCaselle = 1 To SpostaMultiploY(0) ' quante caselle devo spostare
            pictTasto(SpostaMultiploY(nCaselle)).Top = pictTasto(SpostaMultiploY(nCaselle)).Top + DimTessera * SpostaMultiploY(4)
        Next nCaselle

        For nCaselle = 1 To SpostaMultiploX(0) ' quante caselle devo spostare
            pictTasto(SpostaMultiploX(nCaselle)).Left = pictTasto(SpostaMultiploX(nCaselle)).Left + DimTessera * SpostaMultiploX(4)
        Next nCaselle

        '---------------- Alla fine dello spostamento ricreo la sequenza -------------

        SequenzaGenerata = ""
        For Rig = 0 To DimTessera * 3 Step DimTessera
            For Col = 0 To DimTessera * 3 Step DimTessera
                For Ciclo1 = 0 To 14 'trovo l'indice
                    If pictTasto(Ciclo1).Left = Col And pictTasto(Ciclo1).Top = Rig Then
                        Trovato = True
                        Exit For
                    End If
                Next Ciclo1
                If Trovato = False Then
                    SequenzaGenerata = SequenzaGenerata & "16" ' 16  la casella vuota
                Else
                    SequenzaGenerata = SequenzaGenerata & (Ciclo1 + 100 + 1).ToString.Substring(1, 2)
                    Trovato = False
                End If
            Next Col
        Next Rig

        Debug.Print(SequenzaGenerata)
    End Sub

    Private Sub VisualizzaSeq(ByVal Sequenza As String)

        Dim Indice As Short = 0
        Dim Ncasella As Short = 0

        ' scompatta la stringa che contiene la sequenza e posiziona le caselle

        For Ciclo1 = 0 To 30 Step 2 ' la sequenza  lunga 32 caratteri
            Ncasella = CShort(Sequenza.Substring((Ciclo1), 2)) ' posizione per posizione converto in indice
            If Ncasella = 16 Then ' la casella che non c'
                Indice += 1 ' incremento l'indice perch dall'indice ricavo le coordinate
            Else
                pictTasto(Ncasella - 1).Left = DimTessera * (Indice Mod 4) ' coordinata X calcolata
                pictTasto(Ncasella - 1).Top = DimTessera * (Math.Ceiling(Indice \ 4)) ' coordinata Y calcolata
                Indice += 1
            End If
        Next Ciclo1

        SequenzaGenerata = Sequenza ' dopo aver visualizzato aggiorno la variabile SequenzaGenerata, poich contiene lo stato del gioco 
        shpMescolaReale.Visible = False
        Timer1.Enabled = False ' ferma il tempo
        lblinfo.BackColor = Color.White

    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged

        VisualizzaSeq(ArraySequenze(ComboBox1.SelectedIndex, 0)) ' cambia la sequenza visualizzata

    End Sub
End Class